//////////////////////////////////////
// Exception Classes
// by Lengning Liu <lliu1@cs.uky.edu>
//////////////////////////////////////

#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

#include <iostream>
#include <string.h>

using namespace std;

class CMyException
{
 protected:
	static const int MAX_MESSAGE_SIZE = 256;

	char m_Message[MAX_MESSAGE_SIZE];
	
 public:
	CMyException(const char * message)
	{
		int size;

		size = (sizeof(m_Message) > strlen(message)+1) ?
			strlen(message) : sizeof(m_Message);

		memset(m_Message, 0, sizeof(m_Message));
		memcpy(m_Message, message, size);
	}
	
	void dump() const
	{
		cerr<<"Exception was thrown! Here is the message => "<<endl;
		cerr<<"    "<<m_Message<<endl;
	}
};

class CArrayException : public CMyException
{
 public:
	CArrayException()
		: CMyException("Dynamic Array Exception") {};
	CArrayException(const char * mesg)
		: CMyException(mesg) {};
};

class CListException : public CMyException
{
 public:
	CListException()
		: CMyException("List Exception") {};
	CListException(const char * mesg)
		: CMyException(mesg) {};
};

class CHashException : public CMyException
{
 public:
	CHashException()
		: CMyException("Hash Exception") {};
	CHashException(const char * mesg)
		: CMyException(mesg) {};
};

class CSocketException : public CMyException
{
 public:
	CSocketException()
		: CMyException("Socket Exception") {};
	CSocketException(const char * mesg)
		: CMyException(mesg) {};
};

class CThreadException : public CMyException
{
 public:
	CThreadException()
		: CMyException("Thread Exception") {};
	CThreadException(const char * mesg)
		: CMyException(mesg) {};	
};

#endif
